import _slicedToArray from "@babel/runtime/helpers/slicedToArray";

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

import { formatDatetime, formatMoney } from '@billogram/format';
import getRanges from './getRanges';
import mergeOverlappingRanges from './mergeOverlappingRanges';

function getFormattingFunction(type) {
  switch (type) {
    case 'date':
      {
        return function format(value) {
          return formatDatetime(Number(value));
        };
      }

    case 'money':
      {
        return function format(value) {
          return formatMoney(value);
        };
      }

    default:
      {
        if (typeof type === 'function') {
          return type;
        }

        return function format(value) {
          if (typeof value === 'string') {
            return value;
          }

          if (typeof value === 'number') {
            return value.toString();
          }

          return '';
        };
      }
  }
}

export default function highlight(value, matchingTerms, type, callback) {
  var format = getFormattingFunction(type);
  var formattedValue = format(value);
  var formattedMatchingTerms = matchingTerms.map(format);
  var ranges = getRanges(formattedValue, formattedMatchingTerms);
  var merged = mergeOverlappingRanges(ranges);
  var currentIndex = 0;
  var parts = [];

  var _iterator = _createForOfIteratorHelper(merged),
      _step;

  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var _step$value = _slicedToArray(_step.value, 2),
          _start = _step$value[0],
          _end = _step$value[1];

      if (_start > currentIndex) {
        parts.push(formattedValue.slice(currentIndex, _start));
      }

      parts.push(callback(formattedValue.slice(_start, _end), _start, _end));
      currentIndex = _end;
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }

  if (currentIndex < formattedValue.length) {
    parts.push(formattedValue.slice(currentIndex));
  }

  return parts;
}
//# sourceMappingURL=highlight.js.map