import _slicedToArray from "@babel/runtime/helpers/slicedToArray";

function isOverlapping(_ref, _ref2) {
  var _ref3 = _slicedToArray(_ref, 2),
      startX = _ref3[0],
      endX = _ref3[1];

  var _ref4 = _slicedToArray(_ref2, 1),
      startY = _ref4[0];

  return startX <= startY && startY <= endX;
}

export default function mergeOverlappingRanges(items) {
  var ranges = items.slice(0).sort(function (_ref5, _ref6) {
    var _ref7 = _slicedToArray(_ref5, 1),
        startX = _ref7[0];

    var _ref8 = _slicedToArray(_ref6, 1),
        startY = _ref8[0];

    if (startX < startY) {
      return -1;
    }

    if (startX > startY) {
      return 1;
    }

    return 0;
  });
  var merged = [];

  for (var i = 0; i < ranges.length;) {
    // eslint-disable-next-line prefer-const
    var _ranges$i = _slicedToArray(ranges[i], 2),
        start = _ranges$i[0],
        end = _ranges$i[1];

    var offset = 0;

    for (var j = i + offset + 1; j < ranges.length; offset++, j++) {
      if (!isOverlapping([start, end], ranges[j])) {
        break;
      }

      end = Math.max(end, ranges[j][1]);
    }

    merged.push([start, end]);
    i = i + offset + 1;
  }

  return merged;
}
//# sourceMappingURL=mergeOverlappingRanges.js.map