import React from 'react';
import purebem from 'purebem';
import { Link } from '@billogram/react-router';
import { pgettext } from '@billogram/lang';
import './FoundationSearchResultOverview.scss';
export default function FoundationSearchResultOverview(_ref) {
  var _ref$isFetching = _ref.isFetching,
      isFetching = _ref$isFetching === void 0 ? false : _ref$isFetching,
      _ref$items = _ref.items,
      items = _ref$items === void 0 ? [] : _ref$items;
  var block = purebem('foundation-search-result-overview');
  var totalCount = items.reduce(function (sum, item) {
    return sum + (item.count !== void 0 ? item.count : 0);
  }, 0);
  return /*#__PURE__*/React.createElement("div", {
    className: block()
  }, isFetching ? null : /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("header", {
    className: block('header')
  }, pgettext('foundation-search-result-overview', totalCount === 0 ? 'Header--no-matches' : 'Header')), [].map.call(items, function (item) {
    if (item.count === void 0 || item.count === 0) {
      return /*#__PURE__*/React.createElement("div", {
        className: block('item', ['empty']),
        key: item.key
      }, item.title);
    }

    return /*#__PURE__*/React.createElement(Link // eslint-disable-next-line react/forbid-component-props
    , {
      className: block('item', ['default']),
      key: item.key,
      to: item.to
    }, /*#__PURE__*/React.createElement("div", {
      className: block('item-title')
    }, item.title, " (", item.count, ")"), /*#__PURE__*/React.createElement("div", {
      className: block('item-chevron')
    }));
  })));
}
//# sourceMappingURL=FoundationSearchResultOverview.js.map